Sam Ravnborg | ae215b1 | 2006-01-08 18:39:44 +0100 | [diff] [blame] | 1 | #!/bin/sh |
| 2 | # Check ncurses compatibility |
| 3 | |
| 4 | # What library to link |
| 5 | ldflags() |
| 6 | { |
Yaakov Selkowitz | 3725f3e | 2012-06-12 19:05:15 -0500 | [diff] [blame] | 7 | for ext in so a dll.a dylib ; do |
Mike Frysinger | 03c9587 | 2007-05-17 15:06:31 -0400 | [diff] [blame] | 8 | for lib in ncursesw ncurses curses ; do |
| 9 | $cc -print-file-name=lib${lib}.${ext} | grep -q / |
| 10 | if [ $? -eq 0 ]; then |
| 11 | echo "-l${lib}" |
| 12 | exit |
| 13 | fi |
| 14 | done |
| 15 | done |
Sam Ravnborg | 60f33b8 | 2006-01-15 15:28:35 +0100 | [diff] [blame] | 16 | exit 1 |
Sam Ravnborg | ae215b1 | 2006-01-08 18:39:44 +0100 | [diff] [blame] | 17 | } |
| 18 | |
| 19 | # Where is ncurses.h? |
| 20 | ccflags() |
| 21 | { |
Yaakov Selkowitz | 8435425 | 2012-06-12 19:05:02 -0500 | [diff] [blame] | 22 | if [ -f /usr/include/ncursesw/curses.h ]; then |
| 23 | echo '-I/usr/include/ncursesw -DCURSES_LOC="<ncursesw/curses.h>"' |
| 24 | elif [ -f /usr/include/ncurses/ncurses.h ]; then |
Sam Ravnborg | ae215b1 | 2006-01-08 18:39:44 +0100 | [diff] [blame] | 25 | echo '-I/usr/include/ncurses -DCURSES_LOC="<ncurses.h>"' |
| 26 | elif [ -f /usr/include/ncurses/curses.h ]; then |
| 27 | echo '-I/usr/include/ncurses -DCURSES_LOC="<ncurses/curses.h>"' |
| 28 | elif [ -f /usr/include/ncurses.h ]; then |
| 29 | echo '-DCURSES_LOC="<ncurses.h>"' |
| 30 | else |
| 31 | echo '-DCURSES_LOC="<curses.h>"' |
| 32 | fi |
| 33 | } |
| 34 | |
Sam Ravnborg | 3835f82 | 2006-01-21 12:03:09 +0100 | [diff] [blame] | 35 | # Temp file, try to clean up after us |
| 36 | tmp=.lxdialog.tmp |
| 37 | trap "rm -f $tmp" 0 1 2 3 15 |
| 38 | |
Sam Ravnborg | ae215b1 | 2006-01-08 18:39:44 +0100 | [diff] [blame] | 39 | # Check if we can link to ncurses |
| 40 | check() { |
Sam Ravnborg | b44158d | 2008-05-01 19:29:47 +0200 | [diff] [blame] | 41 | $cc -xc - -o $tmp 2>/dev/null <<'EOF' |
| 42 | #include CURSES_LOC |
| 43 | main() {} |
| 44 | EOF |
Sam Ravnborg | ae215b1 | 2006-01-08 18:39:44 +0100 | [diff] [blame] | 45 | if [ $? != 0 ]; then |
Sam Ravnborg | 6e588f6 | 2007-12-09 20:11:15 +0100 | [diff] [blame] | 46 | echo " *** Unable to find the ncurses libraries or the" 1>&2 |
| 47 | echo " *** required header files." 1>&2 |
| 48 | echo " *** 'make menuconfig' requires the ncurses libraries." 1>&2 |
| 49 | echo " *** " 1>&2 |
| 50 | echo " *** Install ncurses (ncurses-devel) and try again." 1>&2 |
| 51 | echo " *** " 1>&2 |
| 52 | exit 1 |
Sam Ravnborg | ae215b1 | 2006-01-08 18:39:44 +0100 | [diff] [blame] | 53 | fi |
| 54 | } |
| 55 | |
| 56 | usage() { |
Sam Ravnborg | f6682f9 | 2008-12-03 22:11:14 +0100 | [diff] [blame] | 57 | printf "Usage: $0 [-check compiler options|-ccflags|-ldflags compiler options]\n" |
Sam Ravnborg | ae215b1 | 2006-01-08 18:39:44 +0100 | [diff] [blame] | 58 | } |
| 59 | |
Mike Frysinger | e99c343 | 2007-05-23 21:37:45 -0400 | [diff] [blame] | 60 | if [ $# -eq 0 ]; then |
Sam Ravnborg | ae215b1 | 2006-01-08 18:39:44 +0100 | [diff] [blame] | 61 | usage |
| 62 | exit 1 |
| 63 | fi |
| 64 | |
Sam Ravnborg | 3835f82 | 2006-01-21 12:03:09 +0100 | [diff] [blame] | 65 | cc="" |
Sam Ravnborg | ae215b1 | 2006-01-08 18:39:44 +0100 | [diff] [blame] | 66 | case "$1" in |
| 67 | "-check") |
| 68 | shift |
Sam Ravnborg | 60f33b8 | 2006-01-15 15:28:35 +0100 | [diff] [blame] | 69 | cc="$@" |
Sam Ravnborg | ae215b1 | 2006-01-08 18:39:44 +0100 | [diff] [blame] | 70 | check |
| 71 | ;; |
| 72 | "-ccflags") |
| 73 | ccflags |
| 74 | ;; |
| 75 | "-ldflags") |
Sam Ravnborg | 60f33b8 | 2006-01-15 15:28:35 +0100 | [diff] [blame] | 76 | shift |
| 77 | cc="$@" |
Sam Ravnborg | ae215b1 | 2006-01-08 18:39:44 +0100 | [diff] [blame] | 78 | ldflags |
| 79 | ;; |
| 80 | "*") |
| 81 | usage |
| 82 | exit 1 |
| 83 | ;; |
| 84 | esac |